VERSION 5.00
Begin VB.Form frmZapTag 
   Caption         =   "ID3 Tag strip/reformat"
   ClientHeight    =   5490
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   8895
   LinkTopic       =   "Form1"
   ScaleHeight     =   5490
   ScaleWidth      =   8895
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command2 
      Caption         =   "&Open"
      Height          =   375
      Left            =   120
      TabIndex        =   2
      Top             =   0
      Width           =   735
   End
   Begin VB.CommandButton Command1 
      Caption         =   "&Fix"
      Height          =   375
      Left            =   960
      TabIndex        =   1
      Top             =   0
      Width           =   735
   End
   Begin VB.ListBox List1 
      Height          =   3375
      Left            =   0
      TabIndex        =   0
      Top             =   480
      Width           =   4815
   End
   Begin VB.Label lblFolder 
      BorderStyle     =   1  'Fixed Single
      Height          =   375
      Left            =   1920
      TabIndex        =   3
      Top             =   0
      Width           =   5055
   End
End
Attribute VB_Name = "frmZapTag"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim fso As FileSystemObject
Dim temppath As String
Dim newfile As String
Dim fil As File
Dim fldr As Folder
Dim i As Integer

Dim mp3path As String
Dim iID3Pos As Long
Dim sMP3ID As String
Dim ifile As Integer
Dim fname As String
Dim newTag As String
Dim diff As Long
Dim totdiff As Long
Dim modified As Boolean
  
Private Sub copytag(fname As String)
   ifile = FreeFile
'   On Error Resume Next
   Open fname For Binary Access Read Lock Write As #ifile
      
   iID3Pos = Get_ID3V2_pos(ifile)
   
      ' If we got an ID3 tag, then try and process it:
   If (iID3Pos > 0) Then
     Seek #ifile, iID3Pos
     Process_ID3V2 ifile
   End If
  
End Sub

Private Function Get_ID3V2_pos(ByVal ifile As Integer) As Long
  Const chunksz = 4096
  Dim sBuf As String
  Dim bFinished As Boolean
  Dim iPos As Long
  Dim iBeg As Long
  Dim iMP3pos As Long
  Get_ID3V2_pos = 0
  sMP3ID = Chr(&HFF) & Chr(&HFB)  'start of MP3 audio
  sBuf = String(chunksz, 0)
  
  iPos = 1
  Do While Not bFinished
      Get #ifile, , sBuf
      iBeg = InStr(sBuf, "ID3")
      If iBeg > 0 Then
        bFinished = True
        Get_ID3V2_pos = iPos + iBeg + 2
        Exit Do
      Else
        iMP3pos = InStr(sBuf, sMP3ID)
        If iMP3pos > 0 Then            'found start of MP3
          bFinished = True             'no ID3 tag before MP3
          Exit Do
        End If
        iPos = iPos + chunksz - 3      'position for next chunk (reduce by 3 in case "ID3" is split)
        If (iPos + chunksz >= LOF(ifile)) Then
          bFinished = True              'no ID3 tag before EOF
          Exit Do
        End If
        Seek #ifile, iPos
      End If
  Loop
End Function

Private Sub Process_ID3V2(ByVal ifile As Integer)
  Dim bVer As Byte
  Dim i As Integer
  Dim tagleng As Long
  Dim frameleng As Long
  Dim framepos As Long
  Dim sBuf As String
  Dim pad As String
  
  Dim bFinished As Boolean
  Dim frameid As String
  
  Dim unicode_start As Long
  Dim temp As String
  Dim fsz(3) As Byte      '4 byte new framesize
  
  Get #ifile, , bVer
  If bVer <> 3 Then
    Close #ifile
    Exit Sub
  End If
  
  Get #ifile, , bVer     'filler
  Get #ifile, , bVer     'filler
   
  ' read the length of the ID3 tag
  
  tagleng = getTagSize(ifile)  'add 10 for ID3 header
  
  sBuf = String(Loc(ifile), 0)
  Seek #ifile, iID3Pos - 3 'start of tag
  Get #ifile, , sBuf
  newTag = sBuf           'save tag header
  modified = False
  Do While Not bFinished
    framepos = Seek(ifile)
    frameid = String(4, " ")
    Get #ifile, , frameid
    If StrComp(frameid, String(4, vbNullChar)) = 0 Then
      bFinished = True
      modified = True
      Exit Do
    End If
    frameleng = getFrameSize(ifile)
    Get #ifile, , bVer     'filler
    Get #ifile, , bVer     'filler
    
    Seek #ifile, framepos          'position start of frame
    sBuf = String(frameleng + 10, 0)
    Get #ifile, , sBuf             'get entire frame
    unicode_start = InStr(sBuf, Chr(255) & Chr(254))
    If unicode_start > 0 Then
      temp = StrConv(Mid(sBuf, unicode_start + 2), vbFromUnicode)
      setFrameSize fsz, Len(temp) + 1
      sBuf = frameid & String(7, 0) & temp
      For i = 0 To 3
        Mid(sBuf, i + 5, 1) = Chr(fsz(i))
      Next
    End If
    
    Select Case frameid
      Case "TIT2", "TPE1", "TALB", "TYER", "COMM", "TCON"
        newTag = newTag & sBuf
      Case Else
        modified = True
    End Select
    
    If (tagleng - Seek(ifile)) < 10 Then 'no more tags possible
      bFinished = True
    End If
  Loop
  If Len(newTag) < 4086 Then
    pad = String((4096 - Len(newTag)), 0)   'pad tag to 4095 bytes so MP3 starts at x'1000
    newTag = newTag & pad
  End If
  
  If modified = False Then
    Close #ifile
    Exit Sub
  End If
  If fso.FileExists(newfile) Then
    fso.DeleteFile newfile, True
  End If
  
  Dim ofile As Integer
  ofile = FreeFile
  Open newfile For Binary Access Write As #ofile
  Put #ofile, , newTag
  
  Seek #ifile, tagleng + 1
  Dim iPos As Long
  Dim iChunksize As Long
  Dim bFin As Boolean
  Dim b() As Byte
  bFin = False
  iChunksize = 4096
  ReDim b(0 To iChunksize - 1) As Byte
  iPos = Loc(ifile)
  Do
    If (iPos + iChunksize >= LOF(ifile)) Then
      iChunksize = LOF(ifile) - iPos
      ReDim b(0 To iChunksize - 1) As Byte
      bFin = True
    End If
    Get #ifile, , b
    Put #ofile, , b
    iPos = iPos + iChunksize
    'Debug.Print iPos & " " & Loc(iFile) & " "; Loc(ofile) & " " & (Loc(iFile) - Loc(ofile))
  Loop While Not bFin
  
  Dim sz(3) As Byte      '4 byte new taglength
  setTagSize sz, Len(newTag) - 10
  Seek #ofile, 7
  For i = 0 To 3
     Put #ofile, , sz(i)
  Next
  
  Close #ofile
  Close #ifile
  Dim ffile As File
  Set ffile = fso.GetFile(fname)
  If (ffile.Attributes And ReadOnly) = ReadOnly Then
    ffile.Attributes = ffile.Attributes - ReadOnly
  End If
  fso.CopyFile newfile, fname, True
  ffile.Attributes = ffile.Attributes + ReadOnly
  
  diff = tagleng - Len(newTag)
  totdiff = totdiff + diff
  List1.AddItem diff & vbTab & fname
  List1.ListIndex = List1.ListCount - 1
  DoEvents
 End Sub

Private Function ValidFrame(frameid As String) As Boolean
Select Case frameid
   Case "PCNT", "TRCK", "TENC", "WXXX", "TCOP", "TOPE", _
        "TCOM", "TCON", "COMM", "TYER", "TIT2", "TRCK", _
        "TPE1", "TALB", "WOAF", "WOAR", "WOAS", "WCOM", "USLT", _
        "TLEN", "TPE3", "TPE2", "TPUB", "TSSE", "APIC"
     ValidFrame = True
   Case Else
     ValidFrame = False
  End Select
End Function

Private Function getTagSize(ifile As Integer) As Long
'get next four bytes from file and convert to long
'The ID3v2 tag size is encoded with four bytes where the most
'   significant bit (bit 7) is set to zero in every byte, making a total
'   of 28 bits. The zeroed bits are ignored, so a 257 bytes long tag is
'   represented as $00 00 02 01.
' 'AND' each byte with 127 to zero high order bit then
' multiply by 128 (x'01111111') raised to the Nth position

  Dim bVer As Byte
  Dim i As Integer
  Dim leng As Long
  For i = 3 To 0 Step -1
    Get #ifile, , bVer
    leng = leng + ((bVer And 127) * (128 ^ i))
'    leng = leng + (bVer * (256 ^ i))
  Next
' add 10 for header, padding and length bytes
  getTagSize = leng + 10
'  getSize = leng
End Function

Private Sub setTagSize(bsize() As Byte, ByVal id3size As Long)
'get next four bytes from file and convert to long
'The ID3v2 tag size is encoded with four bytes where the most
'   significant bit (bit 7) is set to zero in every byte, making a total
'   of 28 bits. The zeroed bits are ignored, so a 257 bytes long tag is
'   represented as $00 00 02 01.
' 'AND' each byte with 127 to zero high order bit then
' multiply by 128 (x'01111111') raised to the Nth position

  Dim i As Integer
  Dim leng As Long
  For i = 0 To 3
    leng = id3size And (127 * (128 ^ i))
    leng = leng / (128 ^ i)
    bsize(3 - i) = leng
  Next
End Sub

Private Sub setFrameSize(bsize() As Byte, ByVal size As Long)
  Dim i As Integer
  Dim dividend As Long
  Dim remain As Long
  Dim quotient As Long
  dividend = size
  For i = 0 To 3
    quotient = dividend \ (256 ^ (3 - i))
    dividend = dividend Mod (256 ^ (3 - i))
    bsize(i) = quotient
  Next
End Sub

Private Function getFrameSize(ifile As Integer) As Long
'get next four bytes from file and convert to long
  Dim bVer As Byte
  Dim i As Integer
  Dim leng As Long
  For i = 3 To 0 Step -1
    Get #ifile, , bVer
    leng = leng + (bVer * (256 ^ i))
  Next
  getFrameSize = leng
End Function



Private Sub Command2_Click()
   Dim lpIDList As Long
   Dim sBuffer As String
   Dim szTitle As String
   Dim tBrowseInfo As BrowseInfo

   szTitle = "Select Folder to scan"
   With tBrowseInfo
      .hWndOwner = Me.hWnd
      .lpszTitle = lstrcat(szTitle, "")
      .ulFlags = BIF_RETURNONLYFSDIRS + BIF_DONTGOBELOWDOMAIN
   End With

   lpIDList = SHBrowseForFolder(tBrowseInfo)

   If (lpIDList) Then
      sBuffer = Space(MAX_PATH)
      SHGetPathFromIDList lpIDList, sBuffer
      sBuffer = Left(sBuffer, InStr(sBuffer, vbNullChar) - 1)
      mp3path = sBuffer
      lblFolder.Caption = sBuffer
   End If
End Sub

Private Sub Form_Load()
  sMP3ID = Chr(&HFF) & Chr(&HFB)  'start of MP3 audio
  Set fso = New FileSystemObject
  temppath = fso.GetSpecialFolder(TemporaryFolder).path
  'newfile = "D:\temp\" & fso.GetBaseName(fname) & ".mp3"
  newfile = temppath & "\zaptag.mp3"
  
End Sub

Private Sub Form_Resize()
  If Me.WindowState = vbMinimized Then
    Exit Sub
  End If
  List1.Left = 1
  List1.Height = Me.ScaleHeight - List1.Top
  List1.Width = Me.ScaleWidth
  lblFolder.Width = Me.ScaleWidth - lblFolder.Left - 50
End Sub

Private Sub Command1_Click()
  List1.Clear
'  Set fldr = fso.GetFolder(mp3path)
'  For Each fil In fldr.Files
'    If fso.GetExtensionName(fil.path) = "mp3" Then
'      fname = fil.path
'      copytag fil.path
'    End If
'  Next
  Screen.MousePointer = vbHourglass
  ScanRecurs mp3path
  Screen.MousePointer = vbDefault
  
  List1.AddItem totdiff & " bytes", 0
  If fso.FileExists(newfile) Then
    fso.DeleteFile newfile, True
  End If
End Sub

Private Sub ScanRecurs(path)
  Dim fldrs As Folders
  Dim subfldr As Folder
  Dim fldr As Folder
  Dim fils As Files
  Dim fil As File

  If fso.FolderExists(path) = False Then
    Exit Sub
  End If
  Set fldr = fso.GetFolder(path)
  If fso.GetParentFolderName(path) <> "" Then
    If (fldr.Attributes And Hidden) = Hidden Then
      If (fldr.Attributes And System) = System Then
        Exit Sub
      End If
    End If
  End If
  
  List1.AddItem path
  List1.ListIndex = List1.ListCount - 1
  DoEvents
  
  Set fils = fldr.Files
  For Each fil In fils
    If UCase(fso.GetExtensionName(fil.path)) = "MP3" Then
      fname = fil.path
      copytag fil.path
    End If
  Next
  
  Set fldrs = fldr.SubFolders
  For Each subfldr In fldrs
    ScanRecurs subfldr.path
  Next
End Sub

